package Friends;

class Friends{ // hash table without support for deletion
	String[] key;  // Keys
	Entry[] data;  // Data
	int size;

	Friends(int maxFriends) {
		data = new Entry[maxFriends];
		key = new String[maxFriends];
		size = 0;
	}
	
	void Grow()
	{
		Entry[] oldData = data;
		String[] oldKey = key;
		data = new Entry[data.length*2];
		key = new String[data.length*2];
		for (int i = 0; i<oldData.length; ++i)
			if (oldKey[i] != null)
				Set(oldKey[i], oldData[i]);
	}

	int Hash(String name){
		int value = 0;
		int m = key.length;
		for (int i = 0; i < name.length(); ++i){
			int c = (int)name.charAt(i);
			value = (value * 31 % m + c % m) % m;
		}
		return value;
	}
	
	public int Probe(String k){
		int index = Hash(k);
		while(key[index] != null && key[index] != k)
			index = (index + 1) % key.length;
		return index;
	}

	// Set data at index of k to f, replace data if k present, create new if not present
	public void Set(String k, Entry f){
		int index = Probe(k);
		boolean add = key[index] == null;
		data[index] = f;
		if (add){
			key[index]= k;
			size++;
			if (size == key.length) // this is a bit late...
				Grow();
		}
	}
	
	Entry Get(String k){
		return data[Probe(k)];
	}
}
