package OnlineStatistics;

public class StatisticsBuffered {
	  double data[];      // Zirkulrer Puffer
	  int numberElements; // Fllgrad
	  int position;       // momentane Position

	  // Konstruktor
	  StatisticsBuffered(int maxSize) {
	    numberElements = 0;
	    data = new double[maxSize];
	  }

	  // fge Wert in die den zirkulren Puffer ein
	  public void Put(double value){
	    data[position] = value;
	    if (numberElements < data.length)
	      numberElements++;
	    position = (position + 1) % data.length;
	  }
	  public double Mean() {
		    double sum = 0;
		    for (int i=0; i<numberElements;++i)
		      sum += data[i];
		    return sum / numberElements;
		  }

	  public double Variance() {
	    if (numberElements > 1)
	    {
	      double ssq = 0;
	      double mean = Mean();
	      for (int i=0; i<numberElements; ++i)
	        ssq += (data[i]-mean)*(data[i]-mean);
	       return ssq / (numberElements-1);
	     }
		  else
	        return 0;
	  }
}
