package live;
import java.util.Scanner;

// Erster Versuch mit zirkulrer Liste
class Statistics{
	private double data[];
	private int n; // Fllgrad
	private int pos; // momentane Position
	
	public Statistics(){
		n = 0; 
		pos = 0;
		data = new double[8];
	}
	
	public void put(double value){
		data[pos] = value;
		if (n<data.length)
			n++;
		pos = (pos + 1) % data.length;
	}

	public double Mean(){
		if (n==0) return 0;
		double sum = 0;
		for (int i = 0; i<n; ++i)
		{
			sum += data[i];
		}
		return sum / n;
	}
	
	public double Variance(){
		if (n<2) return 0;
		double sum = 0;
		double mean = Mean();
		for (int i = 0; i<n; ++i)
		{
			sum += (data[i]-mean) * (data[i]-mean);
		}
		return sum / (n-1);
	}
}

// Zweiter Versuch mit provisional means algorithmus
/*
class Statistics{
	double mean; // laufender Mittelwert
	double ssq;  // Laufende Summe der Abweichungsquadrate
	double n;	 // Anzahl Datenpunkte
	
	public Statistics(){
		mean = 0; 
		ssq = 0;
		n = 0;
	}
	
	public void put(double value){
		++n;
		double oldMean = mean;
		mean = oldMean + (value-oldMean) / n;
		ssq = ssq + (value - oldMean) * (value - mean);
	}

	public double Mean(){
		return mean;
	}
	
	public double Variance(){
		if (n>1)
			return ssq / (n-1);
		else
			return 0;
	}
}
*/



class Main {

	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);

		// Protokoll 
		// put <numbers> 	: enter series of numbers
		// stat				: output statistics
		// end				: end the program
		// ... 				: output "?"
		
		Statistics stat = new Statistics();
		
		boolean done = false;
		while(!done)
		{
			String s = scanner.next();
			if (s.equals("put"))
			{
				while(scanner.hasNextDouble())
				{
					double value = scanner.nextDouble();
					stat.put(value);
					System.out.println(value);
				}
			}
			else if (s.equals("stat"))
			{
				System.out.println(stat.Mean() + " +/- " + stat.Variance());
			}
			else if (s.equals("end"))
			{
				done = true;
			}
			else
				System.out.println("?");
		}
		
		scanner.close();
		System.out.println("done.");
	}
}
